#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

void ATL_zJIK48x0x48TN48x48x0_a1_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=48, NB=0, KB=48, 
 * lda=48, ldb=48, ldc=0, mu=6, nu=1, ku=16, pf=513
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.0)
 */
{
   #define Nb N
   const double *stM = A + 2304;
   const double *stN = B + (((Nb) << 5)+((Nb) << 4));
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*6*1)/(48*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 16
   const int incAm = 240, incAn = -2304;
   #define incBk 16
   const int incBm = -48, incBn = 48;
   #define incCm 12
   const int incCn = (((ldc) << 1)) - 96;
   double *pC0=C;
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0, rA1, rA2, rA3, rA4, rA5;
   register double rB0;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
         rA0 = beta;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         rC1_0 = pC0[2];
         rC1_0 *= rA0;
         rC2_0 = pC0[4];
         rC2_0 *= rA0;
         rC3_0 = pC0[6];
         rC3_0 *= rA0;
         rC4_0 = pC0[8];
         rC4_0 *= rA0;
         rC5_0 = pC0[10];
         rC5_0 *= rA0;
         for (k=0; k < 3; k++) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[48];
            rA2 = pA0[96];
            rA3 = pA0[144];
            rA4 = pA0[192];
            rC0_0 += rA0 * rB0;
            rA5 = pA0[240];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rA1 = pA0[49];
            rA2 = pA0[97];
            rA3 = pA0[145];
            rA4 = pA0[193];
            rC0_0 += rA0 * rB0;
            rA5 = pA0[241];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rA1 = pA0[50];
            rA2 = pA0[98];
            rA3 = pA0[146];
            rA4 = pA0[194];
            rC0_0 += rA0 * rB0;
            rA5 = pA0[242];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rA1 = pA0[51];
            rA2 = pA0[99];
            rA3 = pA0[147];
            rA4 = pA0[195];
            rC0_0 += rA0 * rB0;
            rA5 = pA0[243];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rA1 = pA0[52];
            rA2 = pA0[100];
            rA3 = pA0[148];
            rA4 = pA0[196];
            rC0_0 += rA0 * rB0;
            rA5 = pA0[244];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rA1 = pA0[53];
            rA2 = pA0[101];
            rA3 = pA0[149];
            rA4 = pA0[197];
            rC0_0 += rA0 * rB0;
            rA5 = pA0[245];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rA1 = pA0[54];
            rA2 = pA0[102];
            rA3 = pA0[150];
            rA4 = pA0[198];
            rC0_0 += rA0 * rB0;
            rA5 = pA0[246];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rA1 = pA0[55];
            rA2 = pA0[103];
            rA3 = pA0[151];
            rA4 = pA0[199];
            rC0_0 += rA0 * rB0;
            rA5 = pA0[247];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rA1 = pA0[56];
            rA2 = pA0[104];
            rA3 = pA0[152];
            rA4 = pA0[200];
            rC0_0 += rA0 * rB0;
            rA5 = pA0[248];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rA1 = pA0[57];
            rA2 = pA0[105];
            rA3 = pA0[153];
            rA4 = pA0[201];
            rC0_0 += rA0 * rB0;
            rA5 = pA0[249];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rA1 = pA0[58];
            rA2 = pA0[106];
            rA3 = pA0[154];
            rA4 = pA0[202];
            rC0_0 += rA0 * rB0;
            rA5 = pA0[250];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rA0 = pA0[11];
            rB0 = pB0[11];
            rA1 = pA0[59];
            rA2 = pA0[107];
            rA3 = pA0[155];
            rA4 = pA0[203];
            rC0_0 += rA0 * rB0;
            rA5 = pA0[251];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rA0 = pA0[12];
            rB0 = pB0[12];
            rA1 = pA0[60];
            rA2 = pA0[108];
            rA3 = pA0[156];
            rA4 = pA0[204];
            rC0_0 += rA0 * rB0;
            rA5 = pA0[252];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rA0 = pA0[13];
            rB0 = pB0[13];
            rA1 = pA0[61];
            rA2 = pA0[109];
            rA3 = pA0[157];
            rA4 = pA0[205];
            rC0_0 += rA0 * rB0;
            rA5 = pA0[253];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rA0 = pA0[14];
            rB0 = pB0[14];
            rA1 = pA0[62];
            rA2 = pA0[110];
            rA3 = pA0[158];
            rA4 = pA0[206];
            rC0_0 += rA0 * rB0;
            rA5 = pA0[254];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rA0 = pA0[15];
            rB0 = pB0[15];
            rA1 = pA0[63];
            rA2 = pA0[111];
            rA3 = pA0[159];
            rA4 = pA0[207];
            rC0_0 += rA0 * rB0;
            rA5 = pA0[255];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            pA0 += incAk;
            pB0 += incBk;
         }
         *pC0 = rC0_0;
         pC0[2] = rC1_0;
         pC0[4] = rC2_0;
         pC0[6] = rC3_0;
         pC0[8] = rC4_0;
         pC0[10] = rC5_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifdef ATL_UCLEANN
#define ATL_zpNBmm_bX ATL_zgpNBmm_bX
#endif

void ATL_zJIK48x0x48TN48x48x0_a1_bX(const int M, const int N, const int K, const double alpha, const double *A, const int lda, const double *B, const int ldb, const double beta, double *C, const int ldc);
void ATL_zJIK48x0x48TN48x48x0_a1_bX(const int M, const int N, const int K, const double alpha, const double *A, const int lda, const double *B, const int ldb, const double beta, double *C, const int ldc);
void ATL_zJIK48x0x48TN48x48x0_a1_b1(const int M, const int N, const int K, const double alpha, const double *A, const int lda, const double *B, const int ldb, const double beta, double *C, const int ldc);

void ATL_zpNBmm_bX(const int M, const int N, const int K, const double alpha, const double *A, const int lda, const double *B, const int ldb, const double beta, double *C, const int ldc)
{
   ATL_zJIK48x0x48TN48x48x0_a1_bX(M, N, K, alpha, A, lda, B, ldb, -beta, C, ldc);
   ATL_zJIK48x0x48TN48x48x0_a1_bX(M, N, K, alpha, A, lda, B+N*ldb, ldb, beta, C+1, ldc);
   ATL_zJIK48x0x48TN48x48x0_a1_bX(M, N, K, alpha, A+M*lda, lda, B+N*ldb, ldb, -1.0, C, ldc);
   ATL_zJIK48x0x48TN48x48x0_a1_b1(M, N, K, alpha, A+M*lda, lda, B, ldb, 1.0, C+1, ldc);
}
